
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在 Xcode 项目中使用 swift package fetch / iVAN</title>

    <meta name="description" content="在 Xcode 项目中使用 swift package fetch 本文讲的是在 Xcode 项目中使用 swift package fetch, 到目前为止,Cocoa with Love 的 git 仓库都使用&quot;git subtrees&quot;来管理相关依赖,所有的依赖都被拷贝并静态存放于依赖方目录下.我希望能找到一种更动态地依赖管理方式来代替现有的方案,同时保持对库使用者的不可见性.(译者注:Cocoa with Love) 我想要使用 Swift 包管理工具(Swift Package Manager)来解决这个问题,但我又不希望所有的仓库 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在 Xcode 项目中使用 swift package fetch</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>本文讲的是在 Xcode 项目中使用 swift package fetch，</b></p>
<p><b><br /></b></p>
<p>到目前为止，Cocoa with Love 的 git 仓库都使用“git subtrees”来管理相关依赖，所有的依赖都被拷贝并静态存放于依赖方目录下。我希望能找到一种更动态地依赖管理方式来代替现有的方案，同时保持对库使用者的不可见性。（译者注：Cocoa with Love）</p>
<p>我想要使用 Swift 包管理工具（Swift Package Manager）来解决这个问题，但我又不希望所有的仓库都必须依赖 Swift 包管理工具才能构建（build）。Swift 包管理工具所支持的构建范围相当有限，我可不愿意给我的库套上这些枷锁。</p>
<p>在本文中，我会讨论一种混合（hybrid）的方法，Swift 包管理工具将替代手工配置 Xcode 项目的方案，充当获取依赖的幕后工具，同时，保持对原有“subtree”形式运行的目标平台和构建结构的支持。</p>
<p>内容</p>
<ul>
<li>依赖管理</li>
<li>展望未来</li>
<li>Swift package fetch</li>
<li>自动化脚本</li>
<li>来试试看吧</li>
<li>总结</li>
</ul>
<h2>依赖管理</h2>
<p>我去年发布的 CwlSignal 库的依赖关系非常的简单：</p>
<p>CwlCatchException ← CwlPreconditionTesting ← CwlUtils ← CwlSignal</p>
<h3>Git subtree</h3>
<p>直到现在，我都一直在使用 Git subtrees。</p>
<p>在本例中，你不需要分别单独地下载每个依赖；如果你看看 CwlSignal 仓库早些时候的结构，就会发现它包含了 CwlUtils，其中又包含了 CwlPreconditionTesting，其中又包含了 CwlCatchException。这和手动将每个文件拷贝到仓库中有相似之处，但它的小优势在于：如果依赖发生了改变，我只需简单地调用一个 subtree pull 就可以将更新同步到依赖方了。</p>
<p>这样的做法有着它的缺陷。在缺乏灵活性的树结构中，你必须沿着文件链，按顺序逐步拉取改动；你无法简单地用一个指令就更新所有的依赖。每个仓库都因为需要包含它的依赖而变得臃肿。而如果你无意间修改了依赖方的依赖树，那么在拉取依赖进行合并（merge）的时候也会遇到一些麻烦。</p>
<p>对于依赖关系简单又轻便的 CwlSignal 库而言，这些都不是什么大问题，但这些问题和困扰我还是得指出来。</p>
<h3>Git submodules</h3>
<p>我也可以试试 git submodule。理论上说，它能更动态地解决 git subtrees 所解决的问题。我觉得 git submodules 应该是一个理想的选择，但实际操作起来发现，git modules 对你的仓库的改变是可见（not transparent）的，而 git 那寒酸地处理方式会把一切弄得晦涩难懂。</p>
<p>你有可能遇到 pull 和 push 指令顺序错乱而最终导致改动丢失的情况。改变依赖目标非常麻烦，而且通常需要你手动修改 “.git” 目录下的内容。GitHub 上面的“Download ZIP”功能变得毫无用处，因为 ZIP 文件就和其它大部分非 git 代码管理方式一样，会忽略对子模块的引用。</p>
<p>submodules 的每个用户都要熟悉 submodule 的结构，并且每次都要微调 git 指令以确保拉取更新仓库的正确性，相比之下，git subtrees 中通常不需要注意这个问题。</p>
<h3>成熟的包管理工具</h3>
<p>我当然也可以用一些成熟的包管理工具，像是 CocoaPods 或是 Carthage。我确实应该进一步改进对这些工具的兼容性，以满足部分 希望 使用它们的用户，但我不希望强迫 所有 用户都使用它们。站在自己的角度出发，我更希望能自己独立掌控工作流，而不是依赖这些工具，让它们来控制工作区（workspace）或是构建配置（build settings）。</p>
<h3>Swift 包管理工具</h3>
<p>于是我选择了 Swift 包管理工具；一个自带构建系统和依赖管理的综合方案。</p>
<p>和我前文提到的几个选项相比，Swift 包管理工具提供了新的特性吗？呃，它确实提供了一个全新的构建系统，但我的主要目标是依赖管理；我并没有想找一个构建系统。</p>
<p>使用 Swift 包管理工具不会出现像 git submodules 那样的诡异的问题，同时，它内嵌于 Swift 中，所以比起 CocoaPods 和 Carthage，它是个更自然的选择 - 尽管我还是不想让使用我的库的用户也必须使用 Swift 包管理工具。</p>
<p>有没有可能只使用 Swift 包管理工具的依赖管理功能，而不使用它的构建系统？</p>
<h2>展望未来</h2>
<p>我刚说“我的主要目标是依赖管理；我并没有想找一个构建系统”的时候，其实我撒了小谎。我 理应 是由于它出色的依赖管理能力而青睐它的，但老实说，我也很想试试 Swift 包管理工具的构建系统。</p>
<p>就像 Apache Maven 和 Rust Cargo，Swift 包管理工具包含了一个具有约定准则的构建系统。尽管一些元数据是在顶层清单（top-level manifest）中声明的，构建过程本身则尽可能由目录下的文件组织结构决定。我可是这种构建系统的忠实粉丝；构建不应该需要大量的配置。如果我们的目录结构遵循了约定，系统应该能够推测出大部分（甚至全部）的构建参数，而不是让开发者每次都列举出方方面面的参数。</p>
<p>我期待着 Swift 包管理工具项目成为 Xcode 模板工程的一种。自动化保持文件在各自模块目录下的逻辑，而不是随意存储在文件系统中却又要持续进行维护。构建参数通过推测生成，而不是在长串的标签和检查器中设置。依赖关系像 Xcode 中的“Debug Memory Graph”一样可视化展示。</p>
<p>但很明显，Xcode 暂时还不支持 Swift 包管理工具（Swift 包管理工具支持 Xcode 但我对反向支持更感兴趣）。而且说实话，在 Swift 包管理工具支持构建应用，支持在 iOS 构建，支持在 watchOS 构建，支持在 tvOS 上构建，支持混语言模块构建，支持含有资源包的构建，并能够管理独立的测试依赖或跨模块内联之前，它甚至无法满足简单如 CwlSignal 库的所有需求。</p>
<p>（译者注：通过 Swift 包管理工具生成的项目，支持使用 <code>swift package generate-xcodeproj</code> 指令转化成普通的 Xcode 项目，但目前 Xcode 项目无法转化成 Swift 包管理工具格式的项目）</p>
<p>但我依然支持你把 Swift 包管理工具作为 次要 构建选择，并希望几年后，它能够成为我的 主要 选择。</p>
<h2>Swift package fetch</h2>
<p>想使用 Swift 包管理工具的依赖管理功能，但不将其作为首要构建系统会导致一些问题。</p>
<p>总的来说我们要完成以下几件事：</p>
<ol>
<li>对 Swift 包管理工具进行支持（包括构建和依赖获取）。</li>
<li>让 Xcode 工程依赖 Swift 包管理工具下载的文件。</li>
<li>确保上述操作对用户的不可见性。</li>
</ol>
<h3>1. 对 Swift 包管理工具进行支持</h3>
<p>配置好 “Package.swift” 文件，向仓库中添加语义上的版本标签并确保依赖的正确拉取只是微不足道的工作。</p>
<p>真正的重点是下列任务（排列顺序无关）：</p>
<ol>
<li>将项目目录层级调整为遵循 Swift 包管理工具约定中规定的结构（本例中涉及所有项目）。</li>
<li>将 Objective-C 和 Swift 混编的模块拆分为独立模块（本例中涉及除 CwlSignal 外所有项目）。</li>
<li>确保在 <code>#if SWIFT_PACKAGE</code> 判断下，<code>import</code> 步骤 2 中所创建的新模块（本例中涉及除 CwlSignal 外所有项目）。</li>
<li>将 “.h” 头文件拆分出来，这样我们就可以通过一个 Xcode 全局头文件或是 Swift-PM 中的模块头文件来一并引入它们（本例中涉及除 CwlSignal 外所有项目）。</li>
<li>确保将步骤 2 中所影响到的模块中的 <code>internal</code> 关键字改为 <code>public</code>，以确保它们能被正常访问（本例中涉及 CwlCatchException）。</li>
<li>移除所有对 <code>DEBUG</code> 或其他非 Swift 包管理工具设置条件的依赖（本例中涉及 CwlDeferredWork 和 CwlUtils、CwlSignal 的测试文件）。</li>
<li>对于具有双向依赖关系的 Objective-C 和 Swift 文件，将 Objective-C 中的依赖改为动态寻找以避免模块循环依赖（本例中涉及 CwlMachBadInstructionHandler）。</li>
<li>移动 Info.plist 文件。这些文件是 Swift 包管理工具自动生成的，但它们必须被手动迁移到 Xcode 中 - Swift 包管理工具必须设置成忽略这些文件（本例中涉及所有项目）。</li>
</ol>
<p>另外，学习了解 Swift 包管理工具的约定和工作模式，并让其引导构建的某些方面的过程也花了我们不少工夫。</p>
<h3>2. 让 Xcode 工程依赖 Swift 包管理工具下载的文件</h3>
<p>在 Swift 3.0 版本中，依赖都被放置在 “./Packages/ModuleName-X.Y.Z” 目录下，X、Y、Z 是相应的语义版本号。显然，这个路径会随着依赖版本的改变而改变。</p>
<p>在 Swift 3.1 以及更新的版本中，依赖被放置在 “./.build/checkout/ModuleName-XXXXXXXX” 目录下，其中 XXXXXXXX 是仓库 URL 的 hash 值。这个 hash 值是可能会变化的，并且据我所知，该路径的格式未在文档中提及而且随时可能改变。</p>
<p>因此，我们不能直接将 Xcode 项目中的路径直接指向上述的目录。我们需要创建一个稳定的符号链接（symlink）而不是依赖可能变化的实际路径。这意味着我们需要想一个简单的办法来确定当下的路径。</p>
<p>我们能在文档定义范围内找到的最靠谱的解决路径问题的方案，源于以下这条指令：</p>
<pre><code>swift package show-dependencies --format json

</code></pre>
<p>这条指令会输出一条 JSON 结构的信息，其中包含了模块名和 checkout 的路径。尽管我们没法保证该结构能保持可靠，但 就目前来说 它在 3.0 到 3.1 版本中都表现良好，这可比遍历整个目录结构好多了。</p>
<p>我们需要将符号链接从一个稳定路径细化为 JSON 文件中所描述的具体路径。</p>
<p>我选择用 “./.build/cwl_symlinks/ModuleName” 路径来存储包含 Swift 3.0 以及 3.1 版本的包管理工具所使用的具体路径的符号链接。尽管这样可能出现依赖模块同名但不同源、不同版本的冲突风险，但若不考虑这细微的可能，该路径应该能稳定地指引 Xcode 找到其依赖项。如果我更新了依赖库的版本或是 hash 值改变了（我常出于测试目的，在本地分支和远端分支间切换）或是其它因素导致路径变化了，我们只需要更新符号链接就可以了。</p>
<p>想让 Xcode 引用符号链接来间接获取路径，而不是立刻解析符号链接还有些棘手。在使用 Swift 3.1 版本的时候，我实际上还在 “./.build/cwl_symlinks/ModuleName” 目录下拷贝了一分 “./.build/checkout/ModuleName-XXXXXXXX” 目录，并将所有文件拖入 Xcode 中，然后再删除该份拷贝，并在 “./.build/cwl_symlinks/ModuleName” 目录下创建指向 “./.build/checkout/ModuleName-XXXXXXXX” 的符号链接。</p>
<h3>3. 确保操作对用户的不可见性</h3>
<p>现在，我们有以下两个对用户可见的操作需要消除：</p>
<ol>
<li>获取依赖时执行的 <code>swift package fetch</code> 指令。</li>
<li>在稳定的目录下，为所有动态获取的依赖创建符号链接文件。</li>
</ol>
<p>要达到目标，我们需要写一个自动化脚本。</p>
<h2>自动化脚本</h2>
<p>我们需要为所有有外部依赖的 Xcode 项目添加一个用来“运行脚本”的构建阶段（“Run Script” build phase）。</p>
<p>当你为 Xcode 添加“运行脚本”的构建阶段时，它默认指向 “/bin/sh”。由于我对 bash 相关指令不熟，所以我把构建阶段的 “Shell” 值改为 “/usr/bin/xcrun –sdk macosx swift”（这么做是因为即便构建目标是 iOS 或其它平台，我仍然需要保证使用了 macOS SDK）并将下列代码添加到脚本中。其中的一些解析和配置逻辑或许有些复杂，但配合注释你应该可以理解大致的思路。</p>
<pre><code>import Foundation

/// Launch a process and run to completion, returning the standard out on success.
func launch(_ command: String, _ args: [String], directory: String? = nil) -&gt; String? {
   let proc = Process()
   proc.launchPath = command
   proc.arguments = args
   _ = directory.map { proc.currentDirectoryPath = $0 }
   let pipe = Pipe()
   proc.standardOutput = pipe
   proc.launch()
   let result = String(data: pipe.fileHandleForReading.readDataToEndOfFile(),
      encoding: .utf8)!
   proc.waitUntilExit()
   return proc.terminationStatus != 0 ? nil : result
}

let srcRoot = ProcessInfo.processInfo.environment["SRCROOT"]!

// STEP 1: use `swift package fetch` to get all dependencies
print(launch("/usr/bin/swift", ["package", "fetch"], directory: srcRoot)!)

// Create a symlink only if it is not already present and pointing to the destination
let symlinksPath = "\(srcRoot)/.build/cwl_symlinks"
func createSymlink(srcRoot: String, name: String, destination: String) throws {
   let location = "\(symlinksPath)/\(name)"
   let link = "../../\(destination)"
   if (try? FileManager.default.destinationOfSymbolicLink(atPath: location)) != link {
      _ = try? FileManager.default.removeItem(atPath: location)
      try FileManager.default.createSymbolicLink(atPath: location, withDestinationPath:
         link)
      print("Created symbolic link: \(location) -&gt; \(link)")
   }
}

// Recursively parse the dependency graph JSON, creating symlinks in our own location
func createSymlinks(srcRoot: String, description: Dictionary&lt;String, Any&gt;, topLevelPath:
   String) throws {
   guard let dependencies = description["dependencies"] as? [Dictionary&lt;String, Any&gt;]
      else { return }
   for dependency in dependencies {
      let path = dependency["path"] as! String
      let relativePath = path.substring(from: path.range(of: topLevelPath)!.upperBound)
      let name = dependency["name"] as! String
      try createSymlink(srcRoot: srcRoot, name: name, destination: relativePath)
      try createSymlinks(srcRoot: srcRoot, description: dependency, topLevelPath:
         topLevelPath)
   }
}

// STEP 2: create symlinks from our stable locations to the fetched locations
let descriptionString = launch("/usr/bin/swift", ["package", "show-dependencies",
   "--format", "json"], directory: srcRoot)!
let descriptionData = descriptionString.data(using: .utf8)!
let description = try JSONSerialization.jsonObject(with: descriptionData, options: [])
   as! Dictionary&lt;String, Any&gt;
let topLevelPath = (description["path"] as! String) + "/"
do {
   try FileManager.default.createDirectory(atPath: symlinksPath,
      withIntermediateDirectories: true, attributes: nil)
   try createSymlinks(srcRoot: srcRoot, description: description, topLevelPath:
      topLevelPath)
   print("Complete.")
} catch {
   print(error)
}
</code></pre>
<p>编译运行这段代码大概会花掉一秒钟时间，时间不长，但如果能在首次运行后就省去这段时间就更好了。你可以向运行脚本的 “Input Files” 列表中添加 <code>$(SRCROOT)/Package.swift</code> 并为每个 Swift 包管理工具所获取到的依赖添加一个<code>$(SRCROOT)/.build/cwl_symlinks/ModuleName</code> （ModuleName 是获取到的模块名）。这就能避免 Xcode 在 “Package.swift” 没有改变或模块符号链接未被删除时反复运行脚本，如此便可以节省一秒的编译时间。</p>
<blockquote><p>说着有点讽刺： 为了避免静态包含依赖项，我转而在每个仓库中静态包含了这个文件。</p></blockquote>
<h2>来试试看吧</h2>
<p>你可以查看或下载 GitHub 上的 CwlCatchException、CwlPreconditionTesting、CwlUtils 以及 CwlSignal 工程。这些工程现在支持在 macOS 上用 Swift 包管理工具进行构建。理论上说，Swift 包管理工具为这其中某些库在 Linux 上运行提供了可能，但这部分内容我们留到下次探索。</p>
<p>这是一次对这些仓库的实验性变更。出于某些原因，我可能犯下了一些错误或是忽略了更好地选择。如果你遇到任何问题或是有任何更好的建议，欢迎在 GitHub 上提交 issue。</p>
<h2>总结</h2>
<p>能把 git subtree 的依赖包含方案替换成一个更动态的方案，我十分开心。</p>
<p>我还十分庆幸有 Swift 包管理工具的支持。它暂时还不支持 Linux（别急嘛）但它的工作流程确实流畅（虽然要修改一大堆路径配置）而且不会特别难用。</p>
<p>如果能够将所有用例都完全转为依赖 Swift 包管理工具，那么事情就变简单了、结构也就更清晰了。但可惜，现版本的 Swift 包管理工具还无法处理大量不同的构建场景（包含其它应用以及在 iOS/watchOS/tvOS 平台构建），所以将 Xcode 当作首选构建环境还是相当必要的，但这意味着你需要集成两者。</p>
<p>“运行脚本”的构建阶段很好的隐藏了拉取依赖的过程。尽管没有网络连接时，首次构建会失败，但正常情况下它应该是不可见的，不需要特殊处理。为“运行脚本”的构建阶段设置好 “Input Files” 和 “Output Files”，能够消除绝大部分场景下构建和运行阶段所产生的额外消耗，因此其不会产生太多影响。</p>
<p>但我确实担心，在 Swift 包管理工具如此频繁的更新率下，这个构建脚本会很容易失效。我知道今后我要时刻关注 Swift 包管理工具的更新 - 尤其是任何可能影响到 <code>swift package show-dependencies --format json</code> 输出结果的。</p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b>原文发布时间为：2017年3月16日</b></p>
<p><b><br /></b></p>
<p><b>本文来自合作伙伴掘金，了解相关信息可以关注掘金网站。</b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 00:54:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/xcode/" title="xcode">xcode</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/swift/" title="swift">swift</a>, <a href="https://www.iamivan.net/tag/git/" title="git">git</a>, <a href="https://www.iamivan.net/tag/fetch/" title="fetch">fetch</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在 Xcode 项目中使用 swift package fetch的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWeV0p.html" rel="bookmark">【IOS-COCOS2D-X 游戏开发之七】整合COCOS2DX的ANDROID项目到XCODE项目中，XCODE编写&amp;amp&semi;编译代码，ANDROID导入打包运行即可！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/667.html 此篇针对较早的-x引擎讲解的,最新的可以参考: [Cocos2d-X(2.x) 游戏开发系列之二]cocos2dx最新2.0.1版本跨平台整合NDK+Xcode,Xcode编写&amp;编译代码,Android导入打包运行即可!   之前有两节介绍了mac下配置Android NDK并搭建Cocos2dX以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVEGOb.html" rel="bookmark">Swift &amp;amp&semi; Objc 在同一个项目中的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在WWDC大会中发布了Swift让人眼前一亮.终于加了很多的现代编程语言该有的东西.很早年以前玩C#3.0+的时候这些差不多类似的 已经用的烂熟的东西终于一点一点的在看Swift Programming Language的时候再唤醒.     Swift较之于OC(Objective-C)在愈发上几乎是一门新的语言了,幸运的是Swift和OC都是出自苹果大家庭,还能在一张桌子上吃饭.也就是说在升级项目 的时候你可以考虑使用Swift开发新的功能,调用已有的部分或者被已有的部分调用.或者在Swif			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrv4VVM.html" rel="bookmark">Swift项目中利用SWRevealViewController实现侧滑菜单&lowbar;Swift</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				像往常一样,我们还是创建一个Demo App 来展示一下具体如何使用SWRevealViewController.这个Demo 很简单,功能上也不完善,主要的目的只是引导你去了解如何实现侧滑菜单. 我们将要实现的侧滑菜单大概是这个样子的: 用户可以单击左上角的列表按钮来显示侧滑菜单 用户也可以右滑内容视图来显示侧滑菜单 侧滑菜单显示的时候,用户可以再次单击列表按钮来关闭它 用户也可以左滑内容区域来关闭它 新建一个 Xcode 项目这篇文章的主要目的是讲解侧滑菜单的实现,所以为了节省你的时间,你可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlGoRb.html" rel="bookmark">代码-利用CocoasPod在Swift项目中使用CorePlot源码出现错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 利用CocoasPod在Swift项目中使用CorePlot源码出现错误 利用CocoasPod在Swift项目中使用CorePlot,最后运行程序时CorePlot源码出现错误,说函数出现问题,只需要0个参数而代码给了3个参数,可是我没有动过源码,有大神知道问题出在哪里么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmB757z.html" rel="bookmark">《Swift iOS应用开发实战》&mdash;&mdash;3&period;2Calculator项目中的控制器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.2Calculator项目中的控制器 在Calculator项目中,ViewController.swift文件中所定义的ViewController类就是一个视图控制器,与它关联的视图就是Main.storyboard文件中ViewController场景里面的View,如图3-2所示.如果我们选择故事板中ViewController场景中的控制器,然后按Command+Option+3快捷键切换到标识检视窗,就会看到Custom Class部分的Class被设置为ViewControll			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRy3qb.html" rel="bookmark">【IOS】解决XCODE项目出现MY MAC 64-BIT&sol;设置允许用户外部资源同步到APP&sol;解决CODESIGN ERROR&colon; CERTIFICATE IDENTITY &OpenCurlyQuote;IPHONE DISTRIBUTION&ast;&ast;&ast;APPEARS MORE THAN ONCE IN THE KEYCHAIN &period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/iphone-cocos2d/621.html 本章节Himi为大家总结几点经常用到的功能或者经常出现的问题以及解决方法: 本章节主要介绍3个知识点: 1. 解决Xcode中选择设备运行项目时,设备一栏现实&quot;My mac 64-bit&quot;问题: 2.设置允许用户利用itunes同步一些资源到我们的App中: 3.解决CodeSign			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGJZep.html" rel="bookmark">如何自动增加和从代码读取Xcode项目的版本号</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大熊猫猪·侯佩原创或翻译作品.欢迎转载,转载请注明出处. 如果觉得写的不好请多提意见,如果觉得不错请多多支持点赞.谢谢! hopy ;) Xcode项目和版本号相关的有2个地方Version和Build: 如果需要自动更新版本号有2种方法,都需要写脚本. 一种是用Xcode帮你做好的工具,脚本如下: xcrun agvtool next-version -all 希望进一步了解详情的童鞋可以移步到以下2个地址中查看细节: 使用agvtool 自动化操作version and Build Numb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4B3rM.html" rel="bookmark">上个项目中写的Ant build文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目 一.上一个项目中写的,可以编译.自动化测试.打包的build.xml &lt;?xml version=&quot;1.0&quot;?&gt;&lt;project name=&quot;SimulatorEL&quot; basedir=&quot;.&quot; default=&quot;all&quot;&gt;&lt;!-- edit by YangHuaWei --&gt; &lt;property name=&quot;build.dir&quot; value=&quot;clas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdv4qM.html" rel="bookmark">怎样在XCODE 6中使用矢量图形？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  iOS应用的视觉形式通常是以图形元素驱动的.在设计开发一款应用时,你需要不同规格的应用图标,例如不同尺寸的Default.png图片,同时还需要为UI的实现准备@1x和@2x图形资源.所有这些图形元素都会让你的产品看上去更吸引人,但弊端也是很明显的--你需要为每种规格的图形元素单独切图.而随着iPhone 6及Plus的发布,我们又多了一套@3x需要处理,事情变得越来越复杂. 幸运的是,苹果在Xcode 6当中给我们带来了一些很棒的工具用以管理图形资源.更棒的是,新的工具和实现方式可以帮我们			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW3mMG.html" rel="bookmark" class="title">三步将 React Native 项目运行在 Web 浏览器上面</a>
					<div>
						React Native 的出现,让前端工程师拥有了使用 JavaScript 编写原生 APP 的能力.相比之前的 Web app 来说,对于性能和用户体验提升了非常多. 但是 React Nati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA6kep.html" rel="bookmark" class="title">管理-C&num; 程序没有正确配置，为什么？</a>
					<div>
						问题描述 C# 程序没有正确配置,为什么? C#程序,用procss打开主程序,提示&quot;该程序没有正确配置&quot;,但是直接在电脑管理器里打开就运行正常,为什么? 解决方案 直接运行正常, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEe86b.html" rel="bookmark" class="title">提高网站权重的基本法则</a>
					<div>
						网站权重可以理解为搜索引擎对该站的认可程度,同时也表示一种权威值.网站的权重越高,即表明搜索引擎对该站点越认可.越信赖.站点的权重越高,排名自然越好,权重不是排名但绝对能左右排名,从而带来的流量也不可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPAmvz.html" rel="bookmark" class="title">PS调色教程：反转片调出西部马场牛仔风格色调</a>
					<div>
						这组片子片子我最早的思路是来自一次摄影展. 是属于业余摄影爱好者拍的风光片.看到那浓厚的深蓝和艳丽的色彩.把我深深的吸引住. : z; I&quot; x) ?8 G* K&amp; k1 f 这次公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvNA8M.html" rel="bookmark" class="title">在asp&period;net中调用Excel 文件</a>
					<div>
						asp.net|excel vb.net源代码&lt;%@ Page Language=&quot;VB&quot; %&gt;&lt;%@ Import Namespace=&quot;System ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNkGZb.html" rel="bookmark" class="title">安装配置Open WebMail架设免费电子邮件服务器</a>
					<div>
						Open WebMail是由Neomail 1.14改写而来的,它具有良好的使用介面以及与Outllook接近的多媒体信件显示能力,并且支持多信件夹.通讯录.POP3外部邮件.邮件规则以及全文检索.读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M917YvM.html" rel="bookmark" class="title">html5 Web开发：防止浏览器假死的方法</a>
					<div>
						在Web开发的时候经常会遇到浏览器不响应事件进入假死状态,甚至弹出&quot;脚本运行时间过长&quot;的提示框,如果出现这种情况说明你的脚本已经失控了. 一个浏览器至少存在三个线程:js引擎线程( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrko5p.html" rel="bookmark" class="title">python通过ssh-powershell监控windows的方法</a>
					<div>
						  本文实例讲述了python通过ssh-powershell监控windows的方法.分享给大家供大家参考.具体分析如下: 对于服务器的监控来说,监控linux不管是自己动手写脚本还是用一些开源的工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY8gWM.html" rel="bookmark" class="title">Photoshop给美女人像更换头发颜色</a>
					<div>
						  Photoshop给美女人像更换头发颜色          最终效果 原图 1.在Photoshop中打开你需要处理的图片,同时做出一些必要的修正. 2.后在工具栏中选择快速选择工具,同时大致选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24wNkp.html" rel="bookmark" class="title">驱动人生6添加打印机功能教程</a>
					<div>
						目前驱动人生官网已经放出了驱动人生6的内测版本,细心的朋友可能发现了在工具大全中新增了添加打印机功能,接下来就为大家介绍驱动人生6添加打印机功能使用教程. 打开驱动人生6,可以看到界面和以前有很大的不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWO6Ob.html" rel="bookmark" class="title">进WinPE蓝屏的三个原因　</a>
					<div>
						1. 错误分析:Windows在启动过程中无法访问系统分区或启动卷. 一般发生在更换主板后第一次启动时, 主要是因为新主板和旧主板的IDE控制器使用了不同芯片组造成的. 有时也可能是病毒或硬盘损伤所引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK5okM.html" rel="bookmark" class="title">路由器怎么重启？两种无线路由器重启方法介绍</a>
					<div>
						在路由器设置中,有时候更改了路由器dns.Wifi无线密码或者其他相关的设置的时候,需要重启路由器才能生效.那么路由器怎么重启?这是不少小白朋友,容易疑惑的一个问题.下面,电脑网管之家小编为大家带来2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Ew9VM.html" rel="bookmark" class="title">Java 批量删除html中注释内容的方法&lowbar;java</a>
					<div>
						其实删除html文本中的注释有很多方法,这里就自己随便写了一个处理方法,权当笔记,有需要的同学可以参考. html文本的注释有几个特点: 1. 成对出现,有开始就一定有结束. 2. 注释标签没有嵌套, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N967z.html" rel="bookmark" class="title">讲座：《B&sol;S项目中前端与后端的配合》（含PPT及MM下载）</a>
					<div>
						本文提供了2010年3月20日,博客园张江聚会时讲座&lt;B/S项目中前端与后端的配合&gt;的相关资料.其中用于演讲的演示,是由&amp;http://www.aliyun.com/zixun/a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqnQ3b.html" rel="bookmark" class="title">C&plus;&plus;中重载输入和输出流对象</a>
					<div>
						问题描述 C++中重载输入和输出流对象 重载输入和输出流对象,可以输入一个学生的信息和输出一个学生的信息:并将学生信息存入文件中. 解决方案 参考:http://blog.csdn.net/jarvi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK1YNb.html" rel="bookmark" class="title">sql-SQL 查询 求大神指点？急。。急</a>
					<div>
						问题描述 SQL 查询 求大神指点?急..急 怎么在登录表中查询一段时间内登录超过三次的玩家ID,一天内登录次数大于1只算登录1次,表中的列有登录ID,登录时间. 解决方案 应该这样写:select  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR9V8b.html" rel="bookmark" class="title">这个22岁的程序猿可以打败比特币吗？</a>
					<div>
						目前成长最快的虚拟货币网络以太坊(Ethereum)的创始人 Vitalik Buterin 试图用他的技术来打破所有规律. The DAO 攻击事件 柏林时间6月17日周五早上8:15,混乱突然间开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rJ4dp.html" rel="bookmark" class="title">iOS 使用 WKWebView 无法截获上、下手势的问题解决</a>
					<div>
						iOS 与 Java 服务器之间 SSL 握手失败的解决:Cipher Suites 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeyr7b.html" rel="bookmark" class="title">VC&plus;&plus;常用数据类型转换</a>
					<div>
						 刚接触VC编程的朋友往往对许多数据类型的转换感到迷惑不解,本文将介绍一些常用数据类型的使用.    我们先定义一些常见类型变量借以说明    int i = 100;  long l = 2001; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rgqkz.html" rel="bookmark" class="title">大神们，winform RowHeaderMouseDoubleClick事件总是获取上一次双击的</a>
					<div>
						问题描述 如果不重新运行程序,返回重新点击就是上一次选择的,怎么解决呢 解决方案					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60ENAz.html" rel="bookmark" class="title">怎么实现重新开始</a>
					<div>
						问题描述 怎么在button里实现重新开始游戏, 解决方案 解决方案二:先判断游戏是不是在运行中,如果是,就结束游戏(关闭游戏进程)再重新运行privatevoidGameRun_Click(obje ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNn36oM.html" rel="bookmark" class="title">对象-空指针异常问题，怎么修改？</a>
					<div>
						问题描述 空指针异常问题,怎么修改? public ResultSet executeQuery(String sql) { try { // 捕捉异常 conn = getConnection(); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JD1kz.html" rel="bookmark" class="title">cs导出-java swing 程序导出jar 相关问题</a>
					<div>
						问题描述 java swing 程序导出jar 相关问题 各位大神,我一直都在做BS程序,最近弄一个CS程序,在Eclipse中运行没有任何问题,但是导出时出现了一些问题,如下: 1 将整个CS项目导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXlllb.html" rel="bookmark" class="title">关于myeclipse8&period;6与webSphere8&period;5</a>
					<div>
						问题描述 如何将webSphere8.5集成到myeclipse8.6中.就像在myeclipse中使用tomcat一样使用webSphere8.5.请问可以做到吗.新手.求关照. 解决方案 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jX24p.html" rel="bookmark" class="title">PHP中对Session和Cookie的使用例子</a>
					<div>
						我们跟踪用户信息时需要用到Session和Cookie,比如用户登录验证.记录用户浏览历史,存储购物车数据,限制用户会话有效时间等.今天我们来了解下PHP是如何操作Session和Cookie的. S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NaRxp.html" rel="bookmark" class="title">Android判断是否为飞行模式简单方法&lowbar;Android</a>
					<div>
						判断是否为飞行模式:   复制代码 代码如下: boolean isAirplaneMode = Settings.System.getInt(mContext.getContentResolver( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4476qz.html" rel="bookmark" class="title">SELECT INTO 语句数据表全表复制备份</a>
					<div>
						select into 语句数据表全表复制备份 select into 语句常用于创建表的备份复件或者用于对记录进行存档. sql select into 语法 您可以把所有的列插入新表: selec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jBBVp.html" rel="bookmark" class="title">怎么限制Apache日志文件大小&lpar;error&period;log、access&period;log&rpar;</a>
					<div>
						如何删除error.log.access.log文件以及限制Apache日志文件大小的方法介绍,Apache服务器下access.log以及error.log日志文件一直没有没有动过,今天wordpr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOa18b.html" rel="bookmark" class="title">jmf视频流-JMF接收到的视频怎样保存为视频文件？</a>
					<div>
						问题描述 JMF接收到的视频怎样保存为视频文件? 从recieveStream中获得的dataSource,如何使用它保存成文件? 我现在已经可以实现局域网内两台主机视频通讯,但是不会将接收到的视频R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPW9yDM.html" rel="bookmark" class="title">4月美国网站排名前50：谷歌第一Facebook第八</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 5月18日消息,据国外媒体报道,美国互联网调查公司 comScore发布的4月份网络活动数据显示,在4月份美国网站排名前50中,谷歌继续以1.55亿的访 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
